#ifndef _s__h
#define _s__h

#if __BORLANDC__< 0x460
#	define __BORLANDCPP3__  // BC 3.0 - 0x420
#elif __BORLANDC__< 0x520
#	define __BORLANDCPP5__  // BC 5.01 - 0x460
#elif __BORLANDC__< 0x540
#	define __BORLANDCPPB1__  // BCPPB 1.0 - 0x520
#elif __BORLANDC__< 0x550
#	define __BORLANDCPPB4__  // BCPPB 4.0 - 0x540
#else
#	define __BORLANDCPPB5__  // BCPPB 5.0 - 0x550
#endif

#if __BORLANDC__ >= 0x520
#	define __BCPPB__  // Borland C++ Builder
#endif

#ifdef SystemHpp
#	define __VCL__ // VCL Compilation
#endif


#ifdef __MSVISUALC__ 
#define __MSVISUALC6__ 
#endif


#ifdef _MSC_VER
#	define __MSCOMP__
#	if _MSC_VER == 1300
#		define __MSVSNET__
#	endif
#endif



#undef __USE_GNU
#include <stdio.h>

// linux
#if defined(__MSDOS__) || defined(_Windows) || defined(WIN32)
#	include <process.h>
#else
#	define __LINUX
#	undef __BORLANDCPP3__
#	include <unistd.h>
#endif



typedef unsigned char  byte;

#ifndef __BORLANDCPP3__
	typedef unsigned short word;
#else
	typedef unsigned int word;
#endif

typedef unsigned long  dword;
typedef   signed char  shortint;
typedef   signed char  sint;


#if defined(__BORLANDC__) && (__BORLANDC__<0x460) && !defined(_WIN32)
typedef byte          bool;
#define true 1
#define false 0
#endif

#if !defined(__BORLANDCPP3__) && !defined(__BORLANDCPP5__) && !defined(__LINUX)
typedef unsigned __int64 qword;
typedef __int64          qint;  // deprecated
typedef __int64          qshort;
#elif defined __LINUX
typedef unsigned long long qword;
typedef long long          qshort;

#endif


#ifdef __BCPPB__
#	define fastcall  __fastcall
#	define published __published
#endif

#define me (*this)
#define _BITIMP(p,q) ~p | q                  // p=>q <=> ~p | q
#define _IMP(p,q) !p || q                  // p=>q <=> ~p | q

namespace mar {

//autodel ptr


// obsolete
template<class Tw, class Tr> class adptri {
	protected:
		Tw d;
	public:
		adptri() : d(NULL) {}
		adptri(Tw co)  : d(co) {}

		~adptri() { delete d; }

		operator Tw&() const { return const_cast<Tw&>(d); }

		Tw operator->() const { return d; }
		Tr operator*()  const { return d; }

		#ifdef __BCPPB__
		template<class P>
			Tr operator[](P co) const { return d[co]; }
		#endif

		// ....
};


template<class T> class adptr {
	protected:
		T* d;
	public:
		adptr() : d(0) {}
		explicit adptr(T* co)  : d(co) {}   // to prevent creating temporaty objects
		adptr(const adptr& co)  : d(new T(*co.d)) {}		
		~adptr() { delete d; }
						
		adptr &operator=(const adptr &co) {
			if (d) delete d;
			if (co.d)
				d = new T(*co.d);
			else
				d = 0;
			return me;
		}
		
		adptr &operator=(T *co) {
			if (d) delete d;
			d = co;
			return me;
		}
		
		operator T*&() const { return const_cast<T*&>(d); }
		
 		T* operator->() const { return d; }
		T& operator*()  const { return d; }
		T* operator->*(int) const { return d; }
		
};


template<class T> class andptr : public adptr< T > {
	public:
		andptr() : adptr< T >(new T())  {}
		andptr(const andptr& co) : adptr< T >(co)  {}
		

		template<class V>
			andptr(V co)  : adptr< T >(new T(co)) {}
		template<class V, class W>
			andptr(V co, W co2)  : adptr< T >(new T(co, co2)) {}
		template<class V, class W, class P>
			andptr(V co, W co2, P co3)  : adptr< T >(new T(co, co2, co3)) {}
			
		andptr &operator=(const andptr &co) {
			if (d) delete d;
			if (co.d)
				d = new T(*co.d);
			else
				d = 0;
			return me;
		}
		
		andptr &operator=(const adptr<T> &co) {
			if (d) delete d;
			if (co.d)
				d = new T(*co.d);
			else
				d = 0;
			return me;
		}
		
		andptr &operator=(T *co) {
			if (d) delete d;
			d = co;
			return me;
		}
			
			
};

/****************************************************************/

// obsolete
template<class Tw, class Tr> class atdptri {
	private:
		Tw d;
	public:
		atdptri() : d(NULL) {}
		atdptri(Tw co)  : d(co) {}

		~atdptri() { delete [] d; }

//		operator Tw () const { return d; }
		operator Tw&() const { return const_cast<Tw&>(d); }

//		operator void* () const { return d; }

		Tw operator->() const { return d; }

		const Tr operator*()  const { return *d; }
		Tr operator*() { return *d; }

		#ifdef __BCPPB__
		template<class P>
			Tr operator[](P co) const { return d[co]; }
		#endif

		// ....
};


template<class T> class atdptr {
	protected:
		T* d;
	public:
		atdptr() : d(0) {}
		explicit atdptr(T* co)  : d(co) {}
		~atdptr() { delete d; }
		
//		atdptr(const atdptr &co)  : d(new ) {}  // we don't know the size of array

		T* operator->() const { return d; }

		const T& operator*() const { return *d; }
		T& operator*() { return (*d); }

		template<class P>
			T& operator[](P co) const { return d[co]; }
			
		operator T*&() const { return const_cast<T*&>(d); }
			
		atdptr &operator=(const atdptr &co);  // you cannot assign arrays - you do not know the size to copy it
		
		atdptr &operator=(T *co) {
			if (d) delete d;
			d = co;
			return me;
		}			
			
			
			
			
			
};

template<class T> class atndptr : public atdptr< T > {
	public:
		atndptr() : atdptr< T >()  {}
		explicit atndptr(T* co)  : atdptr< T >(co) {}
		atndptr(int count)  : atdptr< T >(new T[count]) {}

		atndptr &operator=(const atndptr &co);  // you cannot assign arrays - you do not know the size to copy it
		atndptr &operator=(const atdptr<T> &co);  // you cannot assign arrays - you do not know the size to copy it
		
		atndptr &operator=(T *co) {
			if (d) delete d;
			d = co;
			return me;
		}			
			
};



/*
template<class T>
inline T min(T a, T b) { return a >  b ? b : a; }

template<class T>
inline T max(T a, T b) { return a >= b ? a : b; }
  */

//template<class T1, class T2, class T3>
//class adfnc {


/*

template<class T>
class adfnc {
	private:
		void *pointer
		void *args;




};

  */

} // namespace mar

using namespace mar;

#define finally(instr) catch(...) { instr; throw; } instr

#define exceptclass(abc, anc, text) class abc : public anc { public: virtual const char *what() const throw () { return text; } }

#define foreach(t, i, c) for(t i = (c).begin(); i != (c).end(); ++i)



#endif




